
// TCHART2010View.cpp : CTCHART2010View ʵ
//

#include "stdafx.h"
#include "TCHART2010.h"

#include "TCHART2010Doc.h"
#include "TCHART2010View.h"
#include "TeeChart\panel.h"
#include "TeeChart\pen.h"
#include "TeeChart\teeshadow.h"
#include <GdiplusColor.h>
#include "TeeChart\gradient.h"
#include "TeeChart\aspect.h"
#include "TeeChart\teegdiplus.h"
#include "TeeChart\titles.h"
#include "TeeChart\wall.h"
#include "TeeChart\walls.h"
#include "TeeChart\TeeChartDefines.h"
#include "TeeChart\circulargauge.h"
#include "TeeChart\series.h"
#include "TeeChart\axis.h"
#include "TeeChart\axislabels.h"
#include "TeeChart\teefont.h"
#include "TeeChart\teeshape.h"
#include "TeeChart\gaugeseriespointer.h"
#include "TeeChart\framebrush.h"
#include "TeeChart\axes.h"
#include "TeeChart\gaugepointerrange.h"
#include "TeeChart\framedborder.h"


using namespace Gdiplus;
#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTCHART2010View

IMPLEMENT_DYNCREATE(CTCHART2010View, CView)

BEGIN_MESSAGE_MAP(CTCHART2010View, CView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CTCHART2010View::OnFilePrintPreview)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_TIMER()
END_MESSAGE_MAP()

// CTCHART2010View /

CTCHART2010View::CTCHART2010View()
{
	// TODO: ڴ˴ӹ
	m_nValue = 1;
}

CTCHART2010View::~CTCHART2010View()
{
}

BOOL CTCHART2010View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸
	//  CREATESTRUCT cs ޸Ĵʽ

	return CView::PreCreateWindow(cs);
}

// CTCHART2010View 

void CTCHART2010View::OnDraw(CDC* /*pDC*/)
{
	CTCHART2010Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ڴ˴Ϊӻƴ
}


// CTCHART2010View ӡ


void CTCHART2010View::OnFilePrintPreview()
{
	AFXPrintPreview(this);
}

BOOL CTCHART2010View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return DoPreparePrinting(pInfo);
}

void CTCHART2010View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӶĴӡǰеĳʼ
}

void CTCHART2010View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Ӵӡе
}

void CTCHART2010View::OnRButtonUp(UINT nFlags, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CTCHART2010View::OnContextMenu(CWnd* pWnd, CPoint point)
{
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
}


// CTCHART2010View 

#ifdef _DEBUG
void CTCHART2010View::AssertValid() const
{
	CView::AssertValid();
}

void CTCHART2010View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTCHART2010Doc* CTCHART2010View::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTCHART2010Doc)));
	return (CTCHART2010Doc*)m_pDocument;
}
#endif //_DEBUG


// CTCHART2010View Ϣ

int CTCHART2010View::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  ڴרõĴ
	m_GaugeTotal.Create(NULL, WS_VISIBLE| WS_CHILD, CRect(0,0, 300, 400), this, 900);
	//Round Blue Border
	m_GaugeTotal.GetPanel().GetBorder().SetVisible(FALSE);
	//No Background dark 3D shadow
	m_GaugeTotal.GetPanel().SetBevelOuter(0);
	m_GaugeTotal.GetPanel().SetBevelInner(0);

	//Set Gradient
	m_GaugeTotal.GetPanel().GetShadow().SetVisible(FALSE);
	m_GaugeTotal.GetPanel().SetColor(Color::Transparent);
	m_GaugeTotal.GetPanel().GetGradient().SetVisible(FALSE);

	//No 3D Effect
	m_GaugeTotal.GetAspect().SetView3D(FALSE);
	//Use GDI+
	m_GaugeTotal.GetAspect().GetGDIPlus().SetActive(TRUE);
	//No Walls
	//m_GaugeTotal.GetWalls().SetVisible(FALSE);
	//m_GaugeTotal.GetWalls().GetBack().SetVisible(FALSE);
	//No Title
	m_GaugeTotal.GetHeader().SetVisible(FALSE);
	m_GaugeTotal.GetWalls().GetBack().SetTransparency(50);
	m_GaugeTotal.AddSeries(scCircularGauge);
	m_GaugeTotal.Series(0).GetAsCircularGauge().SetCircled(TRUE);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFace().SetColor(RGB(255, 255, 255));
	m_GaugeTotal.GetAxis().GetBottom().GetLabels().GetFont().SetColor(RGB(0, 0, 0));
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFace().GetGradient().SetVisible(FALSE);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFace().SetTransparency(0);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetGreenLine().SetStartValue(25);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetGreenLine().SetEndValue(100);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetRedLine().SetStartValue(0);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetRedLine().SetEndValue(25);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().SetCircled(TRUE);	
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetOuterBrush().SetBackColor(RGB(0, 0, 255));
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetOuterBrush().SetColor(RGB(0, 0, 255));
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetOuterBrush().GetGradient().SetVisible(FALSE);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetMiddleBrush().SetBackColor(RGB(0, 0, 255));
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetMiddleBrush().SetColor(RGB(0, 0, 255));
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetMiddleBrush().GetGradient().SetVisible(FALSE);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetInnerBrush().SetBackColor(RGB(0, 0, 255));
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetInnerBrush().SetColor(RGB(0, 0, 255));
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetInnerBrush().GetGradient().SetVisible(FALSE);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetFrame().GetShadow().SetVisible(FALSE);

	m_GaugeTotal.Series(0).GetAsCircularGauge().GetAxis().SetVisible(TRUE);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetAxis().GetLabels().GetFont().SetSize(8);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetAxis().SetMinorTickCount(4);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetMinorTicks().SetHorizontalSize(2);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetTicks().SetVerticalSize(12);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetTicks().SetHorizontalSize(3);
	m_GaugeTotal.Series(0).GetAsCircularGauge().GetMinorTicks().SetVerticalSize(2);
	m_GaugeTotal.Series(0).GetAsCircularGauge().SetMinorTickDistance(0);
	m_GaugeTotal.Series(0).GetAsCircularGauge().SetRotateLabels(TRUE);
	m_GaugeTotal.Series(0).GetAsCircularGauge().SetValue(40);
	SetTimer(1, 500, NULL);
	return 0;
}

void CTCHART2010View::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: ڴ˴Ϣ
}

void CTCHART2010View::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ڴϢ/Ĭֵ
	if (m_nValue>100)
	{
		m_nValue = 100;
	}
	m_GaugeTotal.Series(0).GetAsCircularGauge().SetValue((m_nValue++)%100);

	CView::OnTimer(nIDEvent);
}
